program freesurface
    implicit none
    real :: q,b,z,yc1,j,n,yn1,y,f,dx,y0,y1,a,r,sf,bb,fr,g,qq
    parameter(g=9.81)
    integer :: i,counter
    real,dimension(4) :: k

    call criticalnormaldepth(q,b,z,yc1,j,n,yn1,counter,qq)
    q=qq
    write(*,*) 'Enter the initial depth y of flow  ::'
    read(*,*) y
    write(10,*) 'Initial depth of flow y ==',y
    write(10,*)
    select case (counter)
     case (1)
      if (y>yn1) then
       write(*,*) '---Profile M1---'
       write(10,*) '---Profile M1---'
       y0=y
50     do i=1,4,1
        a=(b*y0+z*y0**2)
        r=(b*y0+z*y0**2)/(b+2*y0*sqrt(1+z**2))
        sf=(n**2*q**2)/(a**2*r**(4./3.))
        bb=b+2*z*y0
        fr=(q**2*bb)/(g*a**3)
        f=(j-sf)/(1-fr)
        dx=-20
        k(i)=dx*f
        if (i==3)  then
         y0=y0+k(i)
        else
         y0=y0+k(i)/2
        endif
      enddo
      y1=y+(k(1)+2*k(2)+2*k(3)+k(4))/6
      if (y1>1.01*yn1) then
      write(*,*) y1
      write(10,*) y1
       y0=y1
       y=y1
       goto 50
      endif
     endif
     if ((y>yc1) .and. (y<yn1)) then
      write(*,*) '---Profile M2---'
     write(10,*) '---Profile M2---'
      y0=y
60    do i=1,4,1
       a=(b*y0+z*y0**2)
       r=(b*y0+z*y0**2)/(b+2*y0*sqrt(1+z**2))
       sf=(n**2*q**2)/(a**2*r**(4./3.))
       bb=b+2*z*y0
       fr=(q**2*bb)/(g*a**3)
       f=(j-sf)/(1-fr)
       dx=-20
       k(i)=dx*f
       if (i==3)  then
         y0=y0+k(i)
        else
         y0=y0+k(i)/2
        endif
      enddo
      y1=y+(k(1)+2*k(2)+2*k(3)+k(4))/6
      if (y1<0.99*yn1) then
      write(*,*) y1
      write(10,*) y1
       y0=y1
       y=y1
       goto 60
      endif
     endif
     if (y<yc1) then
      write(*,*) '---Profile M3---'
      write(10,*) '---Profile M3---'
      y0=y
70    do i=1,4,1
       a=(b*y0+z*y0**2)
       r=(b*y0+z*y0**2)/(b+2*y0*sqrt(1+z**2))
       sf=(n**2*q**2)/(a**2*r**(4./3.))
       bb=b+2*z*y0
       fr=(q**2*bb)/(g*a**3)
       f=(j-sf)/(1-fr)
       dx=2
       k(i)=dx*f
      if (i==3)  then
         y0=y0+k(i)
        else
         y0=y0+k(i)/2
        endif
      enddo
      y1=y+(k(1)+2*k(2)+2*k(3)+k(4))/6
      if (y1<0.99*yc1) then
      write(*,*) y1
      write(10,*) y1
       y0=y1
       y=y1
       goto 70
      endif
     endif
    case (2)
      if (y>yc1) then
       write(*,*) '---Profile S1---'
       write(10,*) '---Profile S1---'
       y0=y
80     do i=1,4,1
        a=(b*y0+z*y0**2)
        r=(b*y0+z*y0**2)/(b+2*y0*sqrt(1+z**2))
        sf=(n**2*q**2)/(a**2*r**(4./3.))
        bb=b+2*z*y0
        fr=(q**2*bb)/(g*a**3)
        f=(j-sf)/(1-fr)
        dx=-1
        k(i)=dx*f
        if (i==3)  then
         y0=y0+k(i)
        else
         y0=y0+k(i)/2
        endif
       enddo
      y1=y+(k(1)+2*k(2)+2*k(3)+k(4))/6
      if (y1>1.01*yc1) then
      write(*,*) y1
      write(10,*) y1
       y0=y1
       y=y1
       goto 80
      endif
     endif
     if ((y>yn1) .and. (y<yc1)) then
      write(*,*) '---Profile S2---'
      write(10,*) '---Profile S2---'
      y0=y
90    do i=1,4,1
       a=(b*y0+z*y0**2)
       r=(b*y0+z*y0**2)/(b+2*y0*sqrt(1+z**2))
       sf=(n**2*q**2)/(a**2*r**(4./3.))
       bb=b+2*z*y0
       fr=(q**2*bb)/(g*a**3)
       f=(j-sf)/(1-fr)
       dx=0.5
       k(i)=dx*f
       if (i==3)  then
         y0=y0+k(i)
        else
         y0=y0+k(i)/2
        endif
      enddo
      y1=y+(k(1)+2*k(2)+2*k(3)+k(4))/6
      if (y1>1.01*yn1) then
       write(*,*) y1
       write(10,*) y1
       y0=y1
       y=y1
       goto 90
      endif
     endif
     if (y<yn1) then
      write(*,*) '---Profile S3---'
      write(10,*) '---Profile S3---'
      y0=y
100   do i=1,4,1
       a=(b*y0+z*y0**2)
       r=(b*y0+z*y0**2)/(b+2*y0*sqrt(1+z**2))
       sf=(n**2*q**2)/(a**2*r**(4./3.))
       bb=b+2*z*y0
       fr=(q**2*bb)/(g*a**3)
       f=(j-sf)/(1-fr)
       dx=2
       k(i)=dx*f
       if (i==3)  then
         y0=y0+k(i)
        else
         y0=y0+k(i)/2
        endif
      enddo
      y1=y+(k(1)+2*k(2)+2*k(3)+k(4))/6
      if (y1<0.99*yn1) then
       write(*,*) y1
       write(10,*) y1
       y0=y1
       y=y1
       goto 100
      endif
     endif
    case (3)
     if (y>yc1) then
      write(*,*) '---Profile H2---'
      write(10,*) '---Profile H2---'
      y0=y
110    do i=1,4,1
       a=(b*y0+z*y0**2)
       r=(b*y0+z*y0**2)/(b+2*y0*sqrt(1+z**2))
       sf=(n**2*q**2)/(a**2*r**(4./3.))
       bb=b+2*z*y0
       fr=(q**2*bb)/(g*a**3)
       f=(j-sf)/(1-fr)
       dx=0.5
       k(i)=dx*f
       if (i==3)  then
         y0=y0+k(i)
        else
         y0=y0+k(i)/2
        endif
      enddo
      y1=y+(k(1)+2*k(2)+2*k(3)+k(4))/6
      if (y1>1.01*yc1) then
       write(*,*) y1
       write(10,*) y1
       y0=y1
       y=y1
       goto 110
      endif
     endif
     if (y<yc1) then
      write(*,*) '---Profile H3---'
      write(10,*) '---Profile H3---'
      y0=y
120    do i=1,4,1
       a=(b*y0+z*y0**2)
       r=(b*y0+z*y0**2)/(b+2*y0*sqrt(1+z**2))
       sf=(n**2*q**2)/(a**2*r**(4./3.))
       bb=b+2*z*y0
       fr=(q**2*bb)/(g*a**3)
       f=(j-sf)/(1-fr)
       dx=2
       k(i)=dx*f
      if (i==3)  then
         y0=y0+k(i)
        else
         y0=y0+k(i)/2
        endif
      enddo
      y1=y+(k(1)+2*k(2)+2*k(3)+k(4))/6
      if (y1<0.99*yc1) then
       write(*,*) y1
       write(10,*) y1
       y0=y1
       y=y1
       goto 120
      endif
     endif
    end select
end program freesurface

subroutine criticalnormaldepth(q,b,z,yc1,j,n,yn1,counter,qq)
    implicit none
    real :: q,b,z,yc0,yc1,g,yn0,yn1,j,n,m,qq
    integer :: counter
    parameter (g=9.81)
    open(10,file='data1.txt',access='sequential',status='new')
    write(*,*)
    write(*,*) 'Enter the width of the bottom (m) ::'
    read(*,*) b
    write(10,*) 'b==',b
    write(*,*) 'Enter the slope of the bankings ::'
    read(*,*) z
    write(10,*) 'z==',z
    write(*,*) 'Enter the discharge of the channel (c.m/s) ::'
    read(*,*) q
    write(10,*) 'Q==',q
    qq=q
    write(*,*) 'Enter the slope of the channel ::'
    read(*,*) j
    write(10,*) 'So==',j
    write(*,*) 'Enter Manning number (SI) ::'
    read(*,*) n
    write(10,*) 'n==',n
    yc0=1
20  yc1=yc0-((b*yc0+z*yc0**2)**3-(q**2/g)*(b+2*z*yc0))/(3*(b*yc0+z*yc0**2)**2*(b+2*z*yc0)-(q**2/g)*(2*z))
    if ((abs(yc1-yc0))/yc0>0.01) then
     yc0=yc1
     goto 20
    endif
    write(*,*) 'Critical depth (m) :: ', yc1
    write(10,*)
    write(10,*) 'Critical depth (m) :: ', yc1
    if (j==0) then
     write(*,*)
     write(*,*) "---Horizontal slope (H)---"
     write(10,*)
     write(10,*) "---Horizontal slope (H)---"
     yn1=200
     counter=3
     write(*,*)
     write(*,*) 'Normal depth is "infinite".'
     write(10,*) 'Normal depth is "infinite".'
     goto 40
    endif
    q=(n*q)/(j**(1./2.))
    m=2*sqrt(1+z**2)
    yn0=1
30  yn1=yn0-((b*yn0+z*yn0**2)**(5./3.)-q*(b+m*yn0)**(2./3.))/(5./3.*(b*yn0+z*yn0**2)**(2./3.)*(b+2*z*yn0)-(2*q*m)&
    /(3*(b+m*yn0)**(1/3.)))
    if ((abs(yn1-yn0))/yn0>0.01) then
     yn0=yn1
     goto 30
    endif
    write(*,*) 'Normal depth (m) :: ', yn1
    write(10,*) 'Normal depth (m)  :: ', yn1
    write(10,*)
    if (yc1<yn1) then
     write(*,*)
     write(*,*) '---Mild slope (M)---'
     write(10,*)
     write(10,*) '---Mild slope (M)---'
     counter=1
    else
     write(*,*)
     write(*,*) '---Steep slope (S)---'
     write(10,*)
     write(10,*) '---Steep slope (S)---'
     counter=2
    endif
40  write(*,*)
    return
end
